//
//  UMTransportAddress.h
//  ulibtransport
//
//  Created by Andreas Fink on 14.07.21.
//  Copyright © 2021 Andreas Fink. All rights reserved.
//

#import <ulib/ulib.h>

@class SccpAddress;
@class UMGSMMAP_AddressString;


typedef enum UMTransportAddress_type
{
    UMTransportAddress_SCCP,
    UMTransportAddress_SMS,
} UMTransportAddress_type;

@interface UMTransportAddress : UMObject
{
    UMTransportAddress_type _addressType;
    SccpAddress             *_sccpAddr;
    NSString                *_smsAddr;
}

- (UMTransportAddress *)initWithSMSAddress:(NSString *)addr;
- (UMTransportAddress *)initWithSccpAddress:(SccpAddress *)addr;

@property(readwrite,assign) UMTransportAddress_type addressType;
@property(readwrite,strong) SccpAddress             *sccpAddr;
@property(readwrite,strong) NSString                *smsAddr;

@end

