//
//  UMTransportPacket.h
//  ulibtransport
//
//  Created by Andreas Fink on 14.07.21.
//  Copyright © 2021 Andreas Fink. All rights reserved.
//

#import <ulibasn1/ulibasn1.h>
#import "UMTransportAddress.h"

@class UMTransportSegment;
@interface UMTransportPacket : UMASN1Sequence
{
    UMTransportAddress      *_src;
    UMTransportAddress      *_dst;
    NSDate                  *_created;
    UMSynchronizedArray     *_segments;
    NSInteger               _maxParts;
    NSInteger               _messageReference;
    NSData                  *_packetData;
}

@property(readwrite,strong,atomic) UMTransportAddress       *src;
@property(readwrite,strong,atomic) UMTransportAddress       *dst;
@property(readwrite,strong,atomic)  NSDate                  *created;
@property(readwrite,strong,atomic)  UMSynchronizedArray     *segments;
@property(readwrite,assign,atomic)  NSInteger               maxParts;
@property(readwrite,assign,atomic)  NSInteger               messageReference;
@property(readwrite,strong,atomic)  NSData                  *packetData;

- (BOOL)isComplete;
- (BOOL)isExpired;
- (BOOL)addSegment:(UMTransportSegment *)seg; /* returns true if successful */

@end
