//
//  UMTransportProviderProtocol.h
//  ulibtransport
//
//  Created by Andreas Fink on 15.06.18.
//  Copyright © 2018 Andreas Fink. All rights reserved.
//

#import <ulibasn1/ulibasn1.h>
#import <ulibtcap/ulibtcap.h>

@class UMTransportOpen;
@class UMTransportClose;
@class UMTransportMessage;

@protocol UMTransportProviderProtocol<NSObject>


/* ask UMTransport to provide a new dialog */
- (UMTCAP_UserDialogIdentifier *)getNewUserDialogId;

/* ask UMTransport to connect this dialog to a remote */
- (void)umtransportOpenRequest:(UMTransportOpen *)pdu
                 userReference:(NSString *)userDialogRef
                      dialogId:(UMTCAP_UserDialogIdentifier **)dialogId
                      invokeId:(int64_t *)invokeId
                 remoteAddress:(SccpAddress *)address;

/* the UMTransportService to close a dialog */
- (void)umtransportCloseRequest:(UMTransportClose *)pdu
                       dialogId:(UMTCAP_UserDialogIdentifier *)dialogId
                       invokeId:(int64_t *)invokeId;

/* we send a request to the remote and get a invoke id back for this */
- (void)umtransportTransportRequest:(UMTransportMessage *)pdu
                           dialogId:(UMTCAP_UserDialogIdentifier *)dialogId
                           invokeId:(int64_t *)invokeId;

/* we tell UMTransportService about an answer to an incoming request */
- (void)umtransportTransportResponse:(UMTransportMessage *)pdu
                            dialogId:(UMTCAP_UserDialogIdentifier *)dialogId
                            invokeId:(int64_t)invokeId;

- (UMTCAP_UserDialogIdentifier *)dialogIdentifierForDestination:(SccpAddress *)remoteAddress;

@end

