//
//  UMTransportTask.h
//  ulibtransport
//
//  Created by Andreas Fink on 15.06.18.
//  Copyright © 2018 Andreas Fink. All rights reserved.
//

#import <ulibasn1/ulibasn1.h>
#import "UMTransportErrorCode.h"

@class UMTransportMessage;
@class UMTransportDialog;
@class UMTransportService;

typedef enum UMTransportTaskType
{
    UMTransportTaskType_open = 1,
    UMTransportTaskType_close =2,
    UMTransportTaskType_message = 3,
    UMTransportTaskType_error = 4,
    UMTransportTaskType_exec = 5,
} UMTransportTaskType;

@interface UMTransportTask : UMLayerTask
{
    int64_t                 _invokeId;
    UMTransportTaskType     _taskType;
    UMTransportService      *_service;
    UMTransportMessage      *_msg;
    BOOL                    _incoming;
    UMTransportErrorCode    _errorCode;
}

- (UMTransportTask *)initForService:(UMTransportService *)srv message:(UMTransportMessage *)msg;

- (UMTransportTask *)initForDialog:(UMTransportDialog *)dialog
                          invokeId:(int64_t)invokeId
                             error:(UMTransportErrorCode)errorCode
                          incoming:(BOOL)incoming;

- (UMTransportTask *)initForDialog:(UMTransportDialog *)dialog
                          invokeId:(int64_t)invokeId
                              type:(UMTransportTaskType)tt
                               msg:(UMTransportMessage *)data
                          incoming:(BOOL)incoming;

@property(readwrite,assign) int64_t invokeId;
@property(readwrite,assign) UMTransportTaskType taskType;
@property(readwrite,strong) UMTransportDialog *dialog;
@property(readwrite,strong) UMTransportMessage *msg;
@property(readwrite,assign) BOOL incoming;
@property(readwrite,assign) UMTransportErrorCode errorCode;


@end
