//
//  UMTransportUserProtocol.h
//  ulibtransport
//
//  Created by Andreas Fink on 15.06.18.
//  Copyright © 2018 Andreas Fink. All rights reserved.
//

#import <ulibasn1/ulibasn1.h>
#import <ulibtcap/ulibtcap.h>
@class UMTransportRequest;
@class UMTransportResponse;
@class UMTransportOpen;
@class UMTransportClose;
@class UMTransportOpenAccept;
@class UMTransportCloseAccept;

@protocol UMTransportUserProtocol<NSObject>

/* the UMTransportService asks us for a new reference */
- (NSString *)umtransportGetNewUserReference;

/* the UMTransportService tells us about a new dialog connecting to us */
- (void)umtransportOpenIndication:(UMTransportOpen *)pdu
                    userReference:(NSString *)userDialogRef
                         dialogId:(UMTCAP_UserDialogIdentifier *)dialogId
                    remoteAddress:(SccpAddress *)address;

/* the UMTransportService tells us our open request is confirmed */
- (void)umtransportOpenConfirmation:(UMTransportOpenAccept *)pdu
                           dialogId:(UMTCAP_UserDialogIdentifier *)dialogId
                           invokeId:(int64_t)invokeId;

/* the UMTransportService tells us the dialog is closed now */
- (void)umtransportCloseIndication:(UMTransportClose *)pdu
                     userReference:(NSString *)userDialogRef
                          dialogId:(UMTCAP_UserDialogIdentifier *)dialogId;

/* the UMTransportService tells us our close request is confirmed */
- (void)umtransportCloseConfirmation:(UMTransportCloseAccept *)pdu
                            dialogId:(UMTCAP_UserDialogIdentifier *)dialogId
                            invokeId:(int64_t)invokeId;

/* the UMTransportService tells us the remote side has issued an invoke towards us which we should respond with a dialogTransportResponse */
- (void)umtransportTransportIndication:(UMTransportRequest *)pdu
                         userReference:(NSString *)userDialogRef
                              dialogId:(UMTCAP_UserDialogIdentifier *)dialogId
                              invokeId:(int64_t)invokeId;

/* the UMTransportService tells us about an answer to our request we sent to a remote */
- (void)umtransportTransportConfirmation:(UMTransportResponse *)pdu
                           userReference:(NSString *)userDialogRef
                                dialogId:(UMTCAP_UserDialogIdentifier *)dialogId
                                invokeId:(int64_t)invokeId;

@end

